//
// Servo mode  
//

#include "gertbot.h"

void gertbot::servo_pos_slot()
{ QObject *qto = (QObject *)sender();
  int brd,mot,pos;
  byte id,bpos[2];
  Ui::motor *mtrptr; // 
  if (suppress_updates)
    return; 
  brd = qto->objectName()[0].digitValue();
  mot = qto->objectName()[1].digitValue();
  id=(brd<<2) | mot;
  mtrptr = motor_gui[brd][mot].uipnt;
  pos = mtrptr->sb_servo_pos->value();
  bpos[0] = (byte)((pos>>8)& 0xFF);
  bpos[1] = (byte)( pos    & 0xFF);
  uart_tx((byte)CMD_SERVO_POS,id,bpos[0],bpos[1]);
} // servo_pos_slot


void gertbot::servo_config_slot()
{ QObject *qto = (QObject *)sender();
  int brd,mot,speed,min,max;
  byte mess[12];
  Ui::motor *mtrptr; // 
  if (suppress_updates)
    return; 
  brd = qto->objectName()[0].digitValue();
  mot = qto->objectName()[1].digitValue();
  mess[0]=CMD_SERVO_CONF;
  mess[1]=(brd<<2) | mot;
  mtrptr = motor_gui[brd][mot].uipnt;
  speed = (int)(mtrptr->sb_servo_speed->value()*10);
  mess[2] = (byte)((speed>>8)& 0xFF);
  mess[3] = (byte)( speed    & 0xFF);
  mess[4] = (int)(mtrptr->sb_servo_ramp->value()*10);
  mess[5] = mtrptr->cb_servo_oc->isChecked() ? 0x01 : 0x00;
  min = mtrptr->sb_servo_min->value();
  max = mtrptr->sb_servo_max->value();
  mess[6] = (byte)((min >>8)& 0xFF);
  mess[7] = (byte)( min     & 0xFF);
  mess[8] = (byte)((max>>8) & 0xFF);
  mess[9] = (byte)( max     & 0xFF);
  uart_tx(mess,10,0);
} // servo_config_slot

